ifndef SITE_DEFVARS_I
SITE_DEFVARS_I:=1

GENPORTOFF?=0

PLATFORMDIR=${TOPDIR}/platform
NINJA_REGRESS_DIR=${TOPDIR}/ninja_build/regress

include ${TOPDIR}/platform/mk/defvars.mk

# XXX clean out platform vars.

NETCAT?=nc
PGVERSION=$(shell /usr/pgsql-9.3/bin/postmaster --version | egrep -o [0-9]\.[0-9])

ifndef BUILD_STAGE
 BUILD_STAGE:=PROD
endif

ifdef CALLGRIND
  CMD_PREFIX:=valgrind --tool=callgrind --trace-children=yes
endif

ifdef VALGRIND
  CMD_PREFIX:=valgrind --tool=memcheck --leak-check=full --suppressions=${TOPDIR}/regress/valgrind.supp --leak-resolution=high --num-callers=40 --trace-children=yes --track-origins=yes
endif

ifndef REGRESS_USER_ID
	ifndef JENKINS_ID
		REGRESS_USER_ID := $(shell if [ -f /.dockerenv ]; then echo 500; else id -u; fi)
	else
		REGRESS_USER_ID := ${JENKINS_ID}
	endif
	DEFINECACHE += REGRESS_USER_ID
endif

ifndef USER
	USER := $(shell id -un)
endif
#dontcache

SOURCE_PATH=${shell readlink -f ${TOPDIR}}
TEMPLATES_PATH=${shell readlink -f ${TOPDIR}}/templates/dyn

genport = $(shell expr ${GENPORTOFF} + \( ${REGRESS_USER_ID} - \( ${REGRESS_USER_ID} / 100 \) \* 100 \) \* 200 + 20000 + $(1))

ifndef REGRESS_FAST_DIR
  REGRESS_FAST_DIR=/dev/shm/regress-$(shell id -nu)
#  REGRESS_FAST_DIR=`cd ${TOPDIR} && pwd`
  DEFINECACHE += REGRESS_FAST_DIR
endif

REGRESS_HOST:=$(shell hostname -f | head -1)#cache
REGRESS_COOKIE_DOMAIN:=$(shell hostname -d | head -1)#cache
DEFINECACHE += REGRESS_HOST

REGRESS_HOSTNAME:=$(shell hostname | head -1)#cache
DEFINECACHE += REGRESS_HOSTNAME

REGRESS_SLD_HOSTNAME:=$(shell hostname | cut -d\. -f2-)#cache
DEFINECACHE += REGRESS_SLD_HOSTNAME

REGRESS_HOST_ESCAPED:=$(shell printf "${REGRESS_HOSTNAME}" | sed 's/\./_/g')
DEFINECACHE += REGRESS_HOST_ESCAPED

ifndef REGRESS_BLOCKET_ID
 REGRESS_BLOCKET_ID:=$(shell id -un)
 DEFINECACHE += REGRESS_BLOCKET_ID
endif

HTTPD_WORKER_PORT:=80
HTTPD_PORT:=80
HTTPS_PORT:=443

ifndef REGRESS_PIXEL_PORT
 REGRESS_PIXEL_PORT:=$(call genport,25)
 DEFINECACHE += REGRESS_PIXEL_PORT
endif

ifndef REGRESS_IMAGEPORT
 REGRESS_IMAGEPORT:=$(call genport,1)
 DEFINECACHE += REGRESS_IMAGEPORT
endif

ifndef REGRESS_BIDPORT
 REGRESS_BIDPORT:=$(call genport,35)
 DEFINECACHE += REGRESS_BIDPORT
endif

ifndef REGRESS_STREAMPORT
 REGRESS_STREAMPORT:=$(call genport,33)
 DEFINECACHE += REGRESS_STREAMPORT
endif

ifndef REGRESS_DAVPORT
 REGRESS_DAVPORT:=$(call genport,2)
 DEFINECACHE += REGRESS_DAVPORT
endif

ifndef REGRESS_MOD_IMAGE_PORT
 REGRESS_MOD_IMAGE_PORT:=$(call genport,98)
 DEFINECACHE += REGRESS_MOD_IMAGE_PORT
endif

ifndef REGRESS_MCPORT
 REGRESS_MCPORT:=$(call genport,3)
 DEFINECACHE += REGRESS_MCPORT
endif

ifndef REGRESS_MAMA_MCPORT
 REGRESS_MAMA_MCPORT:=$(call genport,45)
 DEFINECACHE += REGRESS_MAMA_MCPORT
endif 

ifndef REGRESS_ASEARCH_SEARCH_PORT
 REGRESS_ASEARCH_SEARCH_PORT:=$(call genport,10)
 REGRESS_ASEARCH_CMD_PORT:=$(call genport,12)
 REGRESS_ASEARCH_KEEPALIVE_PORT:=$(call genport,14)
 DEFINECACHE += REGRESS_ASEARCH_SEARCH_PORT REGRESS_ASEARCH_CMD_PORT REGRESS_ASEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_FAKESEARCH
 REGRESS_FAKESEARCH:=$(call genport,99)
endif

ifndef REGRESS_CSEARCH_SEARCH_PORT
 REGRESS_CSEARCH_SEARCH_PORT:=$(call genport,20)
 REGRESS_CSEARCH_CMD_PORT:=$(call genport,21)
 REGRESS_CSEARCH_KEEPALIVE_PORT:=$(call genport,38)
 DEFINECACHE += REGRESS_CSEARCH_SEARCH_PORT REGRESS_CSEARCH_CMD_PORT  REGRESS_CSEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_JOSESEARCH_SEARCH_PORT
 REGRESS_JOSESEARCH_SEARCH_PORT:=$(call genport,56)
 REGRESS_JOSESEARCH_CMD_PORT:=$(call genport,57)
 REGRESS_JOSESEARCH_KEEPALIVE_PORT:=$(call genport,58)
 DEFINECACHE += REGRESS_JOSESEARCH_SEARCH_PORT REGRESS_JOSESEARCH_CMD_PORT  REGRESS_JOSESEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_RASEARCH_SEARCH_PORT
 REGRESS_RASEARCH_SEARCH_PORT:=$(call genport,50)
 REGRESS_RASEARCH_CMD_PORT:=$(call genport,51)
 REGRESS_RASEARCH_KEEPALIVE_PORT:=$(call genport,52)
 DEFINECACHE += REGRESS_RASEARCH_SEARCH_PORT REGRESS_RASEARCH_CMD_PORT  REGRESS_RASEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_FILTERD_JSON_PORT
 REGRESS_FILTERD_JSON_PORT:=$(call genport,53)
 REGRESS_FILTERD_CONTROLLER_PORT:=$(call genport,54)
 DEFINECACHE += REGRESS_FILTERD_JSON_PORT REGRESS_FILTERD_CONTROLLER_PORT
endif

ifndef REGRESS_BIDSEARCH_SEARCH_PORT
 REGRESS_BIDSEARCH_SEARCH_PORT:=$(call genport,26)
 REGRESS_BIDSEARCH_CMD_PORT:=$(call genport,27)
 REGRESS_BIDSEARCH_KEEPALIVE_PORT:=$(call genport,28)
 DEFINECACHE += REGRESS_BIDSEARCH_SEARCH_PORT REGRESS_BIDSEARCH_CMD_PORT REGRESS_BIDSEARCH_KEEPALIVE_PORT
endif
 
ifndef REGRESS_NEWS_SEARCH_PORT
 REGRESS_NEWS_SEARCH_PORT:=$(call genport,23)
 REGRESS_NEWS_KEEPALIVE_PORT:=$(call genport,39)
 DEFINECACHE += REGRESS_NEWS_SEARCH_PORT REGRESS_NEWS_KEEPALIVE_PORT
endif

ifndef REGRESS_CAMP_SEARCH_PORT
 REGRESS_CAMP_SEARCH_PORT:=$(call genport,22)
 REGRESS_CAMP_CMD_PORT:=$(call genport,25)
 REGRESS_CAMP_KEEPALIVE_PORT:=$(call genport,40)
 DEFINECACHE += REGRESS_CAMP_SEARCH_PORT REGRESS_CAMP_CMD_PORT REGRESS_CAMP_KEEPALIVE_PORT
endif

ifndef REGRESS_SMSSEARCH_SEARCH_PORT
 REGRESS_SMSSEARCH_SEARCH_PORT:=$(call genport,36)
 REGRESS_SMSSEARCH_CMD_PORT:=$(call genport,37)
 REGRESS_SMSSEARCH_KEEPALIVE_PORT:=$(call genport,41)
 DEFINECACHE += REGRESS_SMSSEARCH_SEARCH_PORT REGRESS_SMSSEARCH_CMD_PORT REGRESS_SMSSEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_MSEARCH_PORT
 REGRESS_MSEARCH_SEARCH_PORT:=$(call genport,42)
 REGRESS_MSEARCH_CMD_PORT:=$(call genport,43)
 REGRESS_MSEARCH_KEEPALIVE_PORT:=$(call genport,44)
 DEFINECACHE += REGRESS_MSEARCH_SEARCH_PORT REGRESS_MSEARCH_CMD_PORT REGRESS_MSEARCH_KEEPALIVE_PORT
endif

ifndef REGRESS_HTTPD_PORT
 REGRESS_HTTPD_PORT:=$(call genport,4)
 DEFINECACHE += REGRESS_HTTPD_PORT
endif

ifndef REGRESS_HTTPD_WORKER_PORT
 REGRESS_HTTPD_WORKER_PORT:=$(call genport,8)
 DEFINECACHE += REGRESS_HTTPD_WORKER_PORT
endif 

ifndef REGRESS_HTTPS_CP_PORT
 REGRESS_HTTPS_CP_PORT:=$(call genport,11)
 DEFINECACHE += REGRESS_HTTPS_CP_PORT
endif

ifndef REGRESS_HTTPS_PORT
 REGRESS_HTTPS_PORT:=$(call genport,13)
 DEFINECACHE += REGRESS_HTTPS_PORT
endif

ifndef HAUNTER_VIEWER_PORT
 HAUNTER_VIEWER_PORT:=$(call genport,69)
 DEFINECACHE += HAUNTER_VIEWER_PORT
endif

ifndef REGRESS_NEXTGEN_PORT
 REGRESS_NEXTGEN_PORT:=$(call genport,17)
 DEFINECACHE += REGRESS_NEXTGEN_PORT
endif

ifndef REGRESSDIR
 REGRESSDIR:=${TOPDIR}/regress/scratch
endif

ifndef REGRESS_TRANS_CFPORT
 REGRESS_TRANS_PORT:=$(call genport,5)
 REGRESS_TRANS_FPORT:=$(call genport,6)
 REGRESS_TRANS_CPORT:=$(call genport,7)
 REGRESS_TRANS_CFPORT:=$(call genport,9)
 DEFINECACHE += REGRESS_TRANS_PORT REGRESS_TRANS_FPORT REGRESS_TRANS_CPORT REGRESS_TRANS_CFPORT
endif

ifndef REGRESS_MAMA_PORT
 REGRESS_MAMA_PORT:=$(call genport,41)
 REGRESS_MAMA_FPORT:=$(call genport,42)
 DEFINECACHE += REGRESS_MAMA_PORT REGRESS_MAMA_FPORT
endif

ifndef BUILD_ARCH
 BUILD_ARCH := $(shell uname -i)
 DEFINECACHE += BUILD_ARCH
endif

APXS?=/usr/sbin/apxs
HTTPD:=/usr/sbin/httpd
HTTPD_WORKER:=/usr/sbin/httpd.worker
HTTPD_MOD_DIR:=/usr/lib64/httpd/modules
PHP_EXT_DIR:=/usr/lib64/php/modules/
PHP_TOOL=php
XVNC_PATH=/usr/bin/Xvnc
NC_LISTEN=nc -l

ifndef APACHE_MINOR
 APACHE_MINOR:= $(shell sed -n 's/^.define AP_SERVER_MINORVERSION[A-Z_]*\ [^0-9]*\([0-9]\)[^0-9]*/\1/p' /usr/include/httpd/ap_release.h)
 DEFINECACHE += APACHE_MINOR
endif


ifndef BRANCHID
 BRANCHID:= $(shell sed -n 's/^Version: \([0-9][0-9]*\)\.\([0-9][0-9]*\)/b\1_\2/p' ${TOPDIR}/rpm/blocket.spec)
 DEFINECACHE += BRANCHID
endif

ifndef BPVSCHEMA
 BPVSCHEMA:= $(shell sed -n 's/^%define bpvschema \([a-zA-Z]*\)/\1/p' ${TOPDIR}/rpm/blocket.spec)
 DEFINECACHE += BPVSCHEMA
endif

ifndef PERL_INSTALL
 PERL_INSTALL:= /lib/$(shell perl -MConfig -le 'print "$$Config{package}/$$Config{version}"')
 DEFINECACHE += PERL_INSTALL
endif

ifndef PYTHON_INSTALL
 PYTHON_INSTALL:= /lib/python/$(shell python -c "import sys; print sys.version_info[0]")
 DEFINECACHE += PYTHON_INSTALL
endif

# spiderpoints daemon.
ifndef REGRESS_SPOINTS_INPORT
 REGRESS_SPOINTS_INPORT:=$(call genport,29)
 REGRESS_SPOINTS_DUMPPORT:=$(call genport,30)
 DEFINECACHE += REGRESS_SPOINTS_INPORT REGRESS_SPOINTS_DUMPPORT
endif

ifndef REGRESS_STATPOINTS_PORT
 REGRESS_STATPOINTS_PORT:=$(call genport,31)
 DEFINECACHE += REGRESS_STATPOINTS_PORT
endif

ifndef REGRESS_REDISSTAT_PORT
 REGRESS_REDISSTAT_PORT:=$(call genport,46)
 DEFINECACHE += REGRESS_REDISSTAT_PORT
endif

##### This config was added in platform/mk/defvars.mk #####
#ifndef REGRESS_REDIS_PORT
# REGRESS_REDIR_PORT:=$(call genport,47)
# DEFINECACHE += REGRESS_REDIS_PORT
#endif
###########################################################
ifndef REGRESS_REDIS_CARDATA_PORT
  REGRESS_REDIS_CARDATA_PORT:=$(call genport,48)
  DEFINECACHE += REGRESS_REDIS_CARDATA_PORT
endif

ifndef REGRESS_REDISEMAIL_PORT
 REGRESS_REDISEMAIL_PORT:=$(call genport,59)
 DEFINECACHE += REGRESS_REDISEMAIL_PORT
endif

ifndef REGRESS_REDISPROMETHEUS_PORT
 REGRESS_REDISPROMETHEUS_PORT:=$(call genport,79)
 DEFINECACHE += REGRESS_REDISPROMETHEUS_PORT
endif

ifndef REGRESS_REDISSESSION_PORT
 REGRESS_REDISSESSION_PORT:=$(call genport,49)
 DEFINECACHE += REGRESS_REDISSESSION_PORT
endif

ifndef REGRESS_REDISDASHBOARD_PORT
 REGRESS_REDISDASHBOARD_PORT:=$(call genport,19)
 DEFINECACHE += REGRESS_REDISDASHBOARD_PORT
endif

ifndef REGRESS_REDISACCOUNTS_PORT
 REGRESS_REDISACCOUNTS_PORT:=$(call genport,55)
 DEFINECACHE += REGRESS_REDISACCOUNTS_PORT
endif

ifndef REGRESS_REDISNEXTGEN_API_PORT
 REGRESS_REDISNEXTGEN_API_PORT:=$(call genport,86)
 DEFINECACHE += REGRESS_REDISNEXTGEN_API_PORT
endif

ifndef REGRESS_REDISWORDSRANKING_PORT
 REGRESS_REDISWORDSRANKING_PORT:=$(call genport,84)
 DEFINECACHE += REGRESS_REDISWORDSRANKING_PORT
endif

ifndef REGRESS_MOBILE_PORT
     REGRESS_MOBILE_PORT:=$(call genport,60)
     DEFINECACHE += REGRESS_MOBILE_PORT
endif

ifndef REGRESS_CREDITS_API_PORT
     REGRESS_CREDITS_API_PORT:=$(call genport,24)
     DEFINECACHE += REGRESS_CREDITS_API_PORT
endif

ifndef REGRESS_YAPOFACT_API_PORT
     REGRESS_YAPOFACT_API_PORT:=$(call genport,10402)
     DEFINECACHE += REGRESS_YAPOFACT_API_PORT
endif

ifndef REGRESS_SUBSCRIPTION_API_PORT
     REGRESS_SUBSCRIPTION_API_PORT:=$(call genport,10302)
     DEFINECACHE += REGRESS_SUBSCRIPTION_API_PORT
endif

ifndef REGRESS_ADS_EVALUATOR_API_PORT
     REGRESS_ADS_EVALUATOR_API_PORT:=$(call genport,10502)
     DEFINECACHE += REGRESS_ADS_EVALUATOR_API_PORT
endif

ifndef REGRESS_BIFROST_API_PORT
     REGRESS_BIFROST_API_PORT:=$(call genport,10202)
     DEFINECACHE += REGRESS_BIFROST_API_PORT
endif

ifndef REGRESS_BIFROST_API_SPORT
     REGRESS_BIFROST_API_SPORT:=$(call genport,10204)
     DEFINECACHE += REGRESS_BIFROST_API_SPORT
endif

ifndef REGRESS_SMS_API_PORT
     REGRESS_SMS_API_PORT:=$(call genport,10103)
     DEFINECACHE += REGRESS_SMS_API_PORT
endif

ifndef REGRESS_WEBPAY_API_PORT
     REGRESS_WEBPAY_API_PORT:=$(call genport,10002)
     DEFINECACHE += REGRESS_WEBPAY_API_PORT
endif

ifndef REGRESS_PGSQL_HOST
 REGRESS_PGSQL_HOST:=${REGRESS_FAST_DIR}/pgsql${GENPORTOFF}/data
 DEFINECACHE += REGRESS_PGSQL_HOST
endif

ifeq ($(BUILD_STAGE),PROD)
    WWW_HOST:=www.yapo.cl
    WWW2_HOST:=www2.yapo.cl
    WWW2_HTTP:=www2.yapo.cl
    MSITE_HOST:=m.yapo.cl
    NGINX_HOST:=stats.yapo.cl
    BDIR=/opt/blocket
else
    WWW_HOST:=$(REGRESS_HOSTNAME):$(REGRESS_HTTPD_WORKER_PORT)
    WWW2_HOST:=$(REGRESS_HOSTNAME):$(REGRESS_HTTPS_PORT)
    WWW2_HTTP:=$(REGRESS_HOSTNAME):$(REGRESS_HTTPD_PORT)
    MSITE_HOST:=$(REGRESS_HOSTNAME):$(REGRESS_MOBILE_PORT)
    NGINX_HOST:=172.21.10.201:4443
    BDIR=$(shell readlink -f ${TOPDIR})/regress_final
endif

ifndef REGRESS_REDIS_CLIENT
	REGRESS_REDIS_CLIENT=/usr/bin/redis-cli
 	DEFINECACHE += REGRESS_REDIS_CLIENT
endif

ifndef REGRESS_FINALDIR	
	REGRESS_FINALDIR=${TOPDIR}/regress_final
 	DEFINECACHE += REGRESS_FINALDIR
endif	

PIXEL_LOG:=${REGRESS_FINALDIR}/logs/pixel_debug.log

#Defining the redis server path, because now we are going to use it instead of the redis in the source code
ifndef REGRESS_REDIS_SERVER
	REGRESS_REDIS_SERVER:=/usr/sbin/redis-server
endif

ifndef REGRESS_BFF_PORT
	REGRESS_BFF_PORT:=$(call genport,30001)
	DEFINECACHE += REGRESS_BFF_PORT
endif

endif #SITE_DEFVARS_I
